$(() => {
const map = $('#map').dxMap({
provider: 'bing',
zoom: 14,
height: 440,
width: '100%',
controls: true,
markers: [{
location: '40.7825, -73.966111',
}, {
location: [40.755833, -73.986389],
}, {
location: { lat: 40.753889, lng: -73.981389 },
}, {
location: 'Brooklyn Bridge,New York,NY',
},
],
routes: [
{
weight: 6,
color: 'blue',
opacity: 0.5,
mode: '',
locations: [
[40.782500, -73.966111],
[40.755833, -73.986389],
[40.753889, -73.981389],
'Brooklyn Bridge,New York,NY',
],
},
],
}).dxMap('instance');
$('#choose-mode').dxSelectBox({
dataSource: ['driving', 'walking'],
value: 'driving',
onValueChanged(data) {
map.option('routes', [$.extend({}, map.option('routes')[0], {
mode: data.value,
})]);
},
});
$('#choose-color').dxSelectBox({
dataSource: ['blue', 'green', 'red'],
value: 'blue',
onValueChanged(data) {
map.option('routes', [$.extend({}, map.option('routes')[0], {
color: data.value,
})]);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.2.3/js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="map"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Set mode</span>
<div id="choose-mode"></div>
</div>
<div class="option">
<span>Route color</span>
<div id="choose-color"></div>
</div>
</div>
</div>
</body>
</html>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option > span {
display: inline-block;
width: 90px;
}
.option > .dx-selectbox {
width: 100%;
max-width: 350px;
display: inline-block;
vertical-align: middle;
}

import React from 'react';
import Map from 'devextreme-react/map';
import SelectBox from 'devextreme-react/select-box';
import { markersData, routesData } from './data.js';
const modes = ['driving', 'walking'];
const routeColors = ['blue', 'green', 'red'];
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
routes: routesData,
};
this.updateRouteMode = this.updateRouteMode.bind(this);
this.updateRouteColor = this.updateRouteColor.bind(this);
}
render() {
return (
<div>
<Map
defaultZoom={14}
height={440}
width="100%"
controls={true}
markers={markersData}
routes={this.state.routes}
provider="bing"
/>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Set mode</span>
<SelectBox
defaultValue="driving"
items={modes}
onValueChanged={this.updateRouteMode}
/>
</div>
<div className="option">
<span>Route color</span>
<SelectBox
defaultValue="blue"
items={routeColors}
onValueChanged={this.updateRouteColor}
/>
</div>
</div>
</div>
);
}
updateRouteMode(e) {
this.setState({
routes: this.state.routes.map((item) => {
item.mode = e.value;
return item;
}),
});
}
updateRouteColor(e) {
this.setState({
routes: this.state.routes.map((item) => {
item.color = e.value;
return item;
}),
});
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option > span {
display: inline-block;
width: 90px;
}
.option > .dx-selectbox {
width: 100%;
max-width: 350px;
display: inline-block;
vertical-align: middle;
}
export const markersData = [{
location: [40.755833, -73.986389],
tooltip: {
text: 'Times Square',
},
}, {
location: '40.7825, -73.966111',
tooltip: {
text: 'Central Park',
},
}, {
location: { lat: 40.753889, lng: -73.981389 },
tooltip: {
text: 'Fifth Avenue',
},
}, {
location: 'Brooklyn Bridge,New York,NY',
tooltip: {
text: 'Brooklyn Bridge',
},
}];
export const routesData = [{
weight: 6,
color: 'blue',
opacity: 0.5,
mode: '',
locations: [
[40.782500, -73.966111],
[40.755833, -73.986389],
[40.753889, -73.981389],
'Brooklyn Bridge,New York,NY',
],
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.1.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.57/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.30/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div>
<DxMap
:zoom="14"
:height="440"
:controls="true"
:markers="markersData"
v-model:routes="routesData"
width="100%"
provider="bing"
/>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Set mode </span>
<DxSelectBox
:items="routeModes"
:on-value-changed="updateRoutesMode"
value="driving"
/>
</div>
<div class="option">
<span>Route color </span>
<DxSelectBox
:items="routeColors"
:on-value-changed="updateRoutesColor"
value="blue"
/>
</div>
</div>
</div>
</template>
<script>
import DxMap from 'devextreme-vue/map';
import DxSelectBox from 'devextreme-vue/select-box';
import { markersData, routesData } from './data.js';
export default {
components: {
DxMap,
DxSelectBox,
},
data() {
return {
markersData,
routesData,
routeModes: ['driving', 'walking'],
routeColors: ['blue', 'green', 'red'],
};
},
methods: {
updateRoutesMode({ value: mode }) {
this.routesData = this.routesData.map((item) => {
item.mode = mode;
return item;
});
},
updateRoutesColor({ value: color }) {
this.routesData = this.routesData.map((item) => {
item.color = color;
return item;
});
},
},
};
</script>
<style>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
display: flex;
align-items: center;
}
.option > span {
display: inline-block;
width: 90px;
}
.option > .dx-selectbox {
width: 100%;
max-width: 350px;
display: inline-block;
vertical-align: middle;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
export const markersData = [{
location: [40.755833, -73.986389],
tooltip: {
text: 'Times Square',
},
}, {
location: '40.7825, -73.966111',
tooltip: {
text: 'Central Park',
},
}, {
location: { lat: 40.753889, lng: -73.981389 },
tooltip: {
text: 'Fifth Avenue',
},
}, {
location: 'Brooklyn Bridge,New York,NY',
tooltip: {
text: 'Brooklyn Bridge',
},
}];
export const routesData = [{
weight: 6,
color: 'blue',
opacity: 0.5,
mode: '',
locations: [
[40.782500, -73.966111],
[40.755833, -73.986389],
[40.753889, -73.981389],
'Brooklyn Bridge,New York,NY',
],
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.47/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.5/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.42/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

<dx-map
provider="bing"
[zoom]="14"
[height]="440"
width="100%"
[controls]="true"
[markers]="markers"
[routes]="routes">
</dx-map>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Set mode</span>
<dx-select-box
[dataSource]="[ 'driving', 'walking' ]"
value="driving"
(onValueChanged)="setMode($event)">
</dx-select-box>
</div>
<div class="option">
<span>Route color</span>
<dx-select-box
[dataSource]="[ 'blue', 'green', 'red' ]"
value="blue"
(onValueChanged)="selectColor($event)">
</dx-select-box>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxMapModule, DxSelectBoxModule } from 'devextreme-angular';
import { Marker, Route, Service } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
providers: [ Service ],
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
preserveWhitespaces: true
})
export class AppComponent {
routes: Route[];
markers: Marker[];
constructor(service: Service) {
this.markers = service.getMarkers();
this.routes = service.getRoutes();
}
setMode(e) {
this.routes = this.routes.map(function(item) {
item.mode = e.value;
return item;
});
}
selectColor(e) {
this.routes = this.routes.map(function(item) {
item.color = e.value;
return item;
});
}
}
@NgModule({
imports: [
BrowserModule,
DxMapModule,
DxSelectBoxModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
::ng-deep .caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .option {
margin-top: 10px;
}
::ng-deep .option > span {
display: inline-block;
width: 90px;
}
::ng-deep .option > .dx-selectbox {
width: 100%;
max-width: 350px;
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export class Marker {
location: any;
}
export class Route {
weight: number;
color: string;
opacity: number;
mode: string;
locations: any[]
}
let markers: Marker[] = [{
location: "40.7825, -73.966111"
}, {
location: [40.755833, -73.986389]
}, {
location: {
lat: 40.753889,
lng: -73.981389
}
}, {
location: "Brooklyn Bridge,New York,NY"
}];
let routes: Route[] = [{
weight: 6,
color: "blue",
opacity: 0.5,
mode: "",
locations: [
[40.782500, -73.966111],
[40.755833, -73.986389],
[40.753889, -73.981389],
"Brooklyn Bridge,New York,NY"
]
}];
@Injectable()
export class Service {
getMarkers(): Marker[] {
return markers;
}
getRoutes(): Route[] {
return routes;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24',
'devextreme-angular': 'npm:devextreme-angular@20.2.6',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>